package com.io.yutian.aulib.serialize.serializers;

import com.io.yutian.aulib.serialize.Serializer;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import net.minecraft.nbt.NBTTagCompound;
import org.bukkit.craftbukkit.v1_18_R2.inventory.CraftItemStack;
import org.bukkit.inventory.ItemStack;
import org.json.JSONObject;

public class ItemStackSerializer implements Serializer<ItemStack> {

    @Override
    public Object serialize(ItemStack value) {
        JSONObject jsonObject = new JSONObject();
        net.minecraft.world.item.ItemStack nmsItemStack = CraftItemStack.asNMSCopy(value);
        jsonObject.put("id", nmsItemStack.c().k().g().a());
        jsonObject.put("Count", nmsItemStack.J());
        NBTTagCompound nbtTagCompound = nmsItemStack.u();
        jsonObject.put("tag", new JSONObject(nbtTagCompound.toString()));
        return jsonObject;
    }

    @Override
    public ItemStack deserialize(Object value) {
        JSONObject jsonObject = (JSONObject) value;
        String arg = jsonObject.toString();
        NBTTagCompound nbtTagCompound;
        try {
            nbtTagCompound = net.minecraft.nbt.MojangsonParser.a(arg);
        } catch (CommandSyntaxException e) {
            e.printStackTrace();
            return null;
        }
        net.minecraft.world.item.ItemStack nmsItemStack = net.minecraft.world.item.ItemStack.a(nbtTagCompound);
        return CraftItemStack.asCraftMirror(nmsItemStack);
    }

}
